# Interface: AttestationServiceStatusResponse

## Hierarchy

* **AttestationServiceStatusResponse**

## Index

### Properties

* [address](_wrappers_attestations_.attestationservicestatusresponse.md#address)
* [affiliation](_wrappers_attestations_.attestationservicestatusresponse.md#affiliation)
* [ageOfLatestBlock](_wrappers_attestations_.attestationservicestatusresponse.md#ageoflatestblock)
* [attestationServiceURL](_wrappers_attestations_.attestationservicestatusresponse.md#attestationserviceurl)
* [attestationSigner](_wrappers_attestations_.attestationservicestatusresponse.md#attestationsigner)
* [blacklistedRegionCodes](_wrappers_attestations_.attestationservicestatusresponse.md#blacklistedregioncodes)
* [blsPublicKey](_wrappers_attestations_.attestationservicestatusresponse.md#blspublickey)
* [ecdsaPublicKey](_wrappers_attestations_.attestationservicestatusresponse.md#ecdsapublickey)
* [error](_wrappers_attestations_.attestationservicestatusresponse.md#error)
* [hasAttestationSigner](_wrappers_attestations_.attestationservicestatusresponse.md#hasattestationsigner)
* [metadataURL](_wrappers_attestations_.attestationservicestatusresponse.md#metadataurl)
* [name](_wrappers_attestations_.attestationservicestatusresponse.md#name)
* [okStatus](_wrappers_attestations_.attestationservicestatusresponse.md#okstatus)
* [rightAccount](_wrappers_attestations_.attestationservicestatusresponse.md#rightaccount)
* [score](_wrappers_attestations_.attestationservicestatusresponse.md#score)
* [signer](_wrappers_attestations_.attestationservicestatusresponse.md#signer)
* [smsProviders](_wrappers_attestations_.attestationservicestatusresponse.md#smsproviders)
* [state](_wrappers_attestations_.attestationservicestatusresponse.md#state)
* [version](_wrappers_attestations_.attestationservicestatusresponse.md#version)

## Properties

###  address

• **address**: *[Address](../modules/_base_.md#address)*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:744](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L744)*

___

###  affiliation

• **affiliation**: *string | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:747](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L747)*

___

###  ageOfLatestBlock

• **ageOfLatestBlock**: *number | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:761](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L761)*

___

###  attestationServiceURL

• **attestationServiceURL**: *string | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:751](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L751)*

___

###  attestationSigner

• **attestationSigner**: *string*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:750](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L750)*

___

###  blacklistedRegionCodes

• **blacklistedRegionCodes**: *string[] | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:756](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L756)*

___

###  blsPublicKey

• **blsPublicKey**: *string*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:746](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L746)*

___

###  ecdsaPublicKey

• **ecdsaPublicKey**: *string*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:745](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L745)*

___

###  error

• **error**: *null | Error*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:754](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L754)*

___

###  hasAttestationSigner

• **hasAttestationSigner**: *boolean*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:749](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L749)*

___

###  metadataURL

• **metadataURL**: *string | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:752](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L752)*

___

###  name

• **name**: *string*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:743](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L743)*

___

###  okStatus

• **okStatus**: *boolean*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:753](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L753)*

___

###  rightAccount

• **rightAccount**: *boolean*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:757](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L757)*

___

###  score

• **score**: *BigNumber*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:748](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L748)*

___

###  signer

• **signer**: *string*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:758](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L758)*

___

###  smsProviders

• **smsProviders**: *string[]*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:755](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L755)*

___

###  state

• **state**: *[AttestationServiceStatusState](../enums/_wrappers_attestations_.attestationservicestatusstate.md)*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:759](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L759)*

___

###  version

• **version**: *string | null*

*Defined in [packages/contractkit/src/wrappers/Attestations.ts:760](https://github.com/celo-org/celo-monorepo/blob/master/packages/contractkit/src/wrappers/Attestations.ts#L760)*
