These Rules apply to any licensee’s use of the Celo Foundation’s wordmarks, designmarks, and similar intellectual property (the “Brand Assets”). By using or reproducing a Brand Asset each licensee (hereinafter referred to individually as “you”) is agreeing to abide by this policy that forms a binding agreement between you and the Celo Foundation (the “Foundation”). If you are using a Brand Asset on behalf of a legal entity such as your employer, you represent that you have the authority to bind such entity, and the terms “you” or “your” shall include such entity. If you do not agree to these Rules, you are not authorized to use the Brand Assets. This policy may be updated by the Foundation at its discretion from time to time.

This policy is intended to promote consistent use of the Brand Assets for the larger community. This makes it easier for people to instantly recognize references to Celo, a decentralized technology, and related products, and prevents market confusion. This policy is also intended to protect the Brand Assets. In following this policy, you help the Celo community protect valuable trademark rights from dilution and disparagement, while strengthening the Celo technology brand identity.

### Ownership of Brand Assets

You acknowledge that the Foundation is the sole and exclusive owner of Celo related trademarks, brand assets, and derivatives thereof. You promise that you will not interfere with the Foundation’s rights in the Brand Assets, including by challenging the Foundation’s use, registration, or application to register any  Brand Asset or by registering any Brand Asset (including any derivative form, and foreign translation or transliteration thereof) yourself anywhere in the world.

### Source Code

The Celo technology and software is open source and free. This means that it is not only available for download free of charge, but you have access to the source code and may modify and redistribute our software subject to certain restrictions.

The protocol package is released under the GNU Lesser General Public License v3, and other packages are released under the Apache License v2.0, unless otherwise specified in the “LICENSE” or similar file at the package's root.

For more details, please read about our source code license and software licensing policy on Github ([Celo Monorepo](https://github.com/celo-org/celo-monorepo/blob/master/LICENSE) and [Celo Blockchain](https://github.com/celo-org/celo-blockchain/blob/master/COPYING)).

### Trademarks

Although the Celo technology is open source and the code is free, it is very important that the Celo community strictly enforce its trademark rights, in order to be able to protect users against people who use the marks to commit fraud. This means that, while you have considerable freedom to redistribute and modify Celo technology and software, there are tight restrictions on your ability to use the Celo names and logos in ways which fall in the domain of trademark law.

For more detail on our trademark licensing, see the Trademark Guidelines below. If you still have questions after reading the policy, please contact: [brand@celo.org](mailto:brand@celo.org).

### Website Content

The text of the Celo.org website is generally licensed under a Creative Commons Attribution (CC BY) or Attribution-ShareAlike (CC BY-SA) license, as indicated. This policy content was adapted from the Mozilla Foundation.

### Website Code

You may use the HTML and CSS files on www.celo.org or other Celo websites for your web site - as long as you use the [Celo Brand Kit](http://celo.org/brand) (the colors, gradients, fonts, etc.). We want your style to contribute to the Celo community, so you can use the Celo Brand Kit, HTML and/or CSS code, but your page should not look like you took the Celo.org page and added your logo. This does not grant you any right to use the trademarks, trade names, service marks, or trade dress of the Celo Foundation.

### Trademark Guidelines

Celo is an open source community. Because the Celo code is available to download and modify, proper use of trademarks is essential to inform users of the entities that stand behind a product or service. When using Celo related trademarks you must comply with these Trademark Guidelines.

The wordmark “Celo” is a registered trademark of the Celo Foundation, held in service of the Celo community. However, this is not a complete list of Celo names, logos, and brand features, all of which are subject to these guidelines.

If you want to report misuse of a Celo related trademark, please contact us here: [brand@celo.org](mailto:brand@celo.org).


You may do the following **without receiving specific permission** from the Celo Foundation (or its affiliates):

* Use Celo wordmarks in text to truthfully refer to and/or link to unmodified Celo programs, products, services, and technologies.
* Use Celo logos in visuals to truthfully refer to and/or to link to the applicable programs, products, services and technologies hosted on the Celo platform.
* Use Celo wordmarks to explain that your software is based on Celo’s open source code, or is compatible with the Celo blockchain.
* Describe a social media account, page, event, or community in accordance with the Social Media Guidelines below and the **[Community Code of Conduct](https://celo.org/code-of-conduct).
* All other uses of a Celo trademark require our prior written permission. This includes any use of a Celo related trademark in a domain name. Contact [brand@celo.org](mailto:brand@celo.org) for more information.

**Do:**

* Give a Celo logo adequate spacing from the other elements on the web page or document (see the [Celo Brand Kit](http://celo.org/experience/brand) for guidelines).
* Use the Celo wordmark only as an adjective, never as a noun or verb. Do not use it in plural or possessive forms. Instead, use the generic term for the Celo product or service following the trademark. For example: “Celo block explorer”, “Celo app”.
* Include a trademark attribution notice. Use a clearly visible notice to provide attribution, such as: “*the Celo trademark is a trademark of the Celo Foundation in the US and other countries.*” 

**Don’t:**

* Don’t use the Celo related trademarks in the name of your business, product, service, app, domain name, publication, or other offering without adding information to clarify the additional service.
* Don’t use marks, logos, company names, slogans, domain names, or designs that are confusingly similar to the Celo related trademarks. 
* Don’t use the Celo related trademarks in a way that incorrectly implies affiliation with, or sponsorship, endorsement, or approval by the Celo Foundation of your products or services.
* Don’t display the Celo related trademarks more prominently than your product, service, or company name.
* Don’t use the Celo related trademarks on merchandise for sale (e.g., selling t-shirts, mugs, etc.)
* Don’t use the Celo related trademarks for any other form of commercial use (e.g. offering technical support services), unless such use is limited to a truthful and descriptive reference.
* Don’t modify the Celo related trademarks, abbreviate them, or combine them with any other symbols, words, or images, or incorporate them into a tagline or slogan.
* Don’t use the Celo related trademarks in a disparaging manner or on materials associated with illegal, unfair, or other activities that do not comply with the Community Code of Conduct (e.g., unlawful trades and fraudulent schemes).

### Social Media Guidelines

In addition to the Trademark Guidelines above, the name and handle of your social media account and any and all pages should not begin with a Celo related trademark. In addition, Celo logos cannot be used in a way that might suggest affiliation with the Celo Foundation, including, but not limited to, the account, profile, or header images. The only exception to these requirements is if you’ve received prior permission from the Celo Foundation.

For example, you cannot name your account, page, or community “Celo Representatives” or “Celo Software.” However, it would be acceptable to name your account, page, or community “Fans of Celo” or “Information about Celo Platform” as long as you do not use the Celo logos or otherwise suggest any affiliation with the Celo Foundation.

**Last updated May 19, 2020**
